LeetCode:84.完全平方数

目录

1.完全平方数


1.完全平方数

这道题通过动态规划来解决

首先我们设dpij表示从前i个完全平方数中凑成j所需的最少数量,设置m为sqrt(n),因为对于一个n来说,所需要的完全平方数大小不会超过sqrt(n),比如16,开完为4,最多需要的完全平方数就到4,不可能到5

对于状态转移方程,分为以下两种情况:

  1. 不选择第i个完全平方数,所以需要从前i - 1个中凑成j,dpij = dpi - 1j
  2. 选择第i个,又分为以下情况:
    1. 选一个i,dpij = dpi - 1j - i \* i + 1
    2. 选两个i,dpij = dpi - 1j - 2 \* (i \* i) + 2
    3. 最终可以表示为,dpij = dpij - i \* i + 1

所以dpij = min(dpi - 1j, dpij - i \* i + 1]

初始化的问题,我们需要用到上一个位置和左边的位置,所以需要从上到下,从左到右的初始化,同时注意边界问题,第0行第j列(1 <= j <= n)应当初始化为一个很大的值,表示不可能被选择,因为不会有从0个完全平方数中凑成j的情况

cpp 复制代码
class Solution {
public:
    int numSquares(int n) {
        const int INF = 0x3f3f3f3f;
        int m = sqrt(n);
        vector<vector<int>> dp(m + 1, vector<int>(n + 1));
        for(int j = 1; j <= n; j++) dp[0][j] = INF;
        for(int i = 1; i <= m; i++)
            for(int j = 0; j <= n; j++)
            {
                dp[i][j] = dp[i - 1][j];
                if(j >= i * i)
                    dp[i][j] = min(dp[i][j], dp[i][j - i * i] + 1);
            }
        return dp[m][n];
    }
};

空间优化后

cpp 复制代码
class Solution {
public:
    int numSquares(int n) {
        const int INF = 0x3f3f3f3f;
        int m = sqrt(n);
        vector<int> dp(n + 1, INF);
        dp[0] = 0;
        for(int i = 1; i <= m; i++)
            for(int j = i * i; j <= n; j++)
                    dp[j] = min(dp[j], dp[j - i * i] + 1);
        return dp[n];
    }
};
相关推荐
leobertlan5 小时前
痛苦系列 | DSP-03 跨越单位圆:Z变换与零极点分析
算法·程序员
蛋蛋的就会顺顺的5 小时前
hot100 p0——栈,贪心算法,动态规划
java·前端·javascript·算法·leetcode·力扣
开发小能手1236 小时前
答案daanC语言
数据结构·算法
Navigator_Z8 小时前
LeetCode //C - 1291. Sequential Digits
c语言·算法·leetcode
pride.li9 小时前
第03章 Python 教程-基础语法:注释与变量
服务器·前端·后端·python·算法·计算机视觉
旺仔仔仔10 小时前
机器人项目实战(5):从单次抓取,到接收指令连续做事
算法
旺仔仔仔10 小时前
机器人项目实战(2):识别物体、提取点云,再到抓取姿态
算法
姜鱼问生10 小时前
密码明明一样,为什么 GPG 说“错的“?
后端·算法·架构
启观川10 小时前
数据结构与算法-第 3 章 常用算法-贪心算法
数据结构·笔记·python·算法·贪心算法
对空六课10 小时前
指标口径生效时间的版本查询实现
大数据·服务器·前端·算法·数据分析